﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;
using System.Windows.Media;
using System.Runtime.InteropServices;
using Styx;
using Styx.Helpers;
using Styx.Common;
using Styx.CommonBot.POI;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace FeralKitty
{
    public partial class Classname : CombatRoutine
    {
        
        public bool faerieSwarm
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(FaerieSwarm)
                    && GetSpellCooldown(FaerieSwarm).TotalSeconds <= 0
                    && !Me.CurrentTarget.ActiveAuras.ContainsKey(FaerieSwarm))
                {
                    if (SpellManager.CanCast(FaerieSwarm))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool faerieFire
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && !SpellManager.HasSpell(FaerieSwarm)
                    && SpellManager.HasSpell(FaerieFire)
                    && GetSpellCooldown(FaerieFire).TotalSeconds <= 0
                    && !Me.CurrentTarget.ActiveAuras.ContainsKey(FaerieFire))
                {
                    if (SpellManager.CanCast(FaerieFire))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool savageRoar
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && Me.ComboPoints == 0
                    && (!Me.HasAura(127538)
                    || MyAuraTimeLeft(127538, Me) < 5)
                    && HaveGlyph("Savagery")
                    && Me.EnergyPercent >= 25)
                {
                    if (SpellManager.CanCast(127538)
                        || SpellManager.CanCast(52610))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool ferociuosbite25
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(FerociousBite)
                    && Me.CurrentTarget.HealthPercent < 25
                    && Me.CurrentTarget.HasAura(Rip)
                    && Me.EnergyPercent >= 25
                    && Me.ComboPoints >= 1
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(FerociousBite))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool ferociuosbite
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(FerociousBite)
                    && Me.CurrentTarget.ActiveAuras.ContainsKey(Rip)
                    && Me.EnergyPercent >= 25
                    && Me.ComboPoints >= myComboPoints
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(FerociousBite))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool thrash
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && Me.ActiveAuras.ContainsKey("Clearcasting")
                    && !Me.CurrentTarget.HasAura(106830)
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    //if (SpellManager.CanCast(106830))
                    //{
                    return true;
                    //}
                }
                return false;
            }
        }
        public bool savageRoarcp
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && Me.CurrentTarget.ActiveAuras.ContainsKey(Rip)
                    && Me.ComboPoints >= 1
                    && (!Me.HasAura(127538)
                    || MyAuraTimeLeft(127538, Me) < 5)
                    && Me.EnergyPercent >= 25)
                {
                    if (SpellManager.CanCast(127538)
                        || SpellManager.CanCast(52610))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool rake
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(Rake)
                    && !Me.CurrentTarget.ActiveAuras.ContainsKey(Rake)
                    && (Me.EnergyPercent >= 35
                    || Me.HasAura(Clearcasting)) 
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(Rake))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool rip
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(Rip)
                    && (!Me.CurrentTarget.ActiveAuras.ContainsKey(Rip)
                    || MyAuraTimeLeft(Rip, Me.CurrentTarget) < 7)
                    && (Me.EnergyPercent >= 35
                    || Me.HasAura(Clearcasting))
                    && Me.ComboPoints >= myComboPoints 
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(Rip))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool mangle
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(Mangle)
                    && Me.EnergyPercent >= 35
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(Mangle))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool tigersfury
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && !Me.HasAura("Lifeblood")
                    && GetSpellCooldown(TigersFury).TotalSeconds <= 0
                    && !Me.HasAura("Bloodlust")
                    && !Me.HasAura("Time Warp")
                    && !Me.HasAura("Heroism")
                    && Me.EnergyPercent < 35)
                {
                    if (SpellManager.CanCast(TigersFury))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool lifeblood
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && !Me.HasAura(TigersFury)
                    && GetSpellCooldown(TigersFury).TotalSeconds > 0
                    && GetSpellCooldown("Lifeblood").TotalSeconds <= 0
                    && !Me.HasAura("Bloodlust")
                    && !Me.HasAura("Time Warp")
                    && !Me.HasAura("Heroism")
                    && Me.EnergyPercent < 35)
                {
                    if (SpellManager.CanCast("Lifeblood"))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool burstboss
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && IsBoss
                    && GetSpellCooldown(Berserk).TotalSeconds <= 0
                    && GetSpellCooldown(Incarnation).TotalSeconds <= 0
                    && FeralKittySettings.AllPrefs.Berserk == 1
                    && Me.EnergyPercent >= 35)
                {
                    return true;
                }
                return false;
            }
        }
        public bool burst
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && GetSpellCooldown(Berserk).TotalSeconds <= 0
                    && GetSpellCooldown(Incarnation).TotalSeconds <= 0
                    && FeralKittySettings.AllPrefs.Berserk == 2
                    && Me.EnergyPercent >= 35)
                {
                    return true;
                }
                return false;
            }
        }
        public bool ravage
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(Ravage)
                    && Me.HasAura("Incarnation: King of the Jungle")
                    && (Me.EnergyPercent >= 45
                    || Me.HasAura(Clearcasting)))
                {
                    if (SpellManager.CanCast(Ravage))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool shred
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(Shred)
                    && Me.CurrentTarget.MeIsSafelyBehind
                    && (Me.CurrentTarget.ActiveAuras.ContainsKey(Rake)
                    || Me.CurrentTarget.HasAura(106830))
                    && (Me.EnergyPercent >= 40
                    || Me.HasAura(Clearcasting))
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(Shred))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public string symbiosis
        {
            get
            {
                string spell = "";

                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell("Death Coil")
                    && GetSpellCooldown("Death Coil").TotalSeconds <= 0
                    && DeathCoil)
                {
                    if (SpellManager.CanCast("Death Coil"))
                    {
                        spell = "Death Coil";
                    }
                }
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell("Feral Spirit")
                    && GetSpellCooldown("Feral Spirit").TotalSeconds <= 0
                    && FeralSpirit)
                {
                    if (SpellManager.CanCast("Feral Spirit"))
                    {
                        spell = "Feral Spirit";
                    }
                }
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell("Shattering Blow")
                    && GetSpellCooldown("Shattering Blow").TotalSeconds <= 0
                    && ShatteringBlow)
                {
                    if (SpellManager.CanCast("Shattering Blow"))
                    {
                        spell = "Shattering Blow";
                    }
                }
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell("Soul Swap")
                    && GetSpellCooldown("Soul Swap").TotalSeconds <= 0
                    && Me.CurrentTarget.ActiveAuras.ContainsKey(Rip)
                    && (Me.CurrentTarget.ActiveAuras.ContainsKey(Rake)
                    || Me.CurrentTarget.HasAura(106830))
                    && SoulSwap)
                {
                    if (SpellManager.CanCast("Soul Swap"))
                    {
                        spell = "Soul Swap";
                    }
                }
                return spell;
            }
        }
        public bool healingtouch
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell("Healing Touch")
                    && !Me.HasAura(108381)
                    && Me.ActiveAuras.ContainsKey(PredatorySwiftness)
                    && MyAuraTimeLeft(69369, Me) > 2)
                {
                    if (SpellManager.CanCast("Healing Touch"))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool swipe
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(Swipe)
                    && (Me.EnergyPercent >= 45
                    || Me.HasAura(Clearcasting))
                    && addCount > 1
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(Swipe))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool thrashaoe
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && (Me.EnergyPercent >= 50
                    || Me.ActiveAuras.ContainsKey("Clearcasting"))
                    && (!Me.CurrentTarget.HasAura(106830)
                    || MyAuraTimeLeft(106830, Me.CurrentTarget) < 3)
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    //if (SpellManager.CanCast(106830))
                    //{
                    return true;
                    //}
                }
                return false;
            }
        }
        public bool mightybash
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(MightyBash)
                    && FeralKittySettings.AllPrefs.MightyBash
                    && GetSpellCooldown(MightyBash).TotalSeconds <= 0
                    && (Me.CurrentTarget.IsCasting
                    && Me.CanInterruptCurrentSpellCast)
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(MightyBash))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool skullbash
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(SkullBash)
                    && FeralKittySettings.AllPrefs.SkullBash
                    && GetSpellCooldown(SkullBash).TotalSeconds <= 0
                    && (Me.CurrentTarget.IsCasting
                    && Me.CanInterruptCurrentSpellCast)
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(SkullBash))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool mightybashbear
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(MightyBashBear)
                    && FeralKittySettings.AllPrefs.MightyBashBear
                    && !spellOnCooldown(MightyBashBear)
                    && (Me.CurrentTarget.IsCasting
                    && Me.CanInterruptCurrentSpellCast)
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(MightyBashBear))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool skullbashbear
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && SpellManager.HasSpell(SkullBashBear)
                    && FeralKittySettings.AllPrefs.SkullBashBear
                    && !spellOnCooldown(SkullBashBear)
                    && (Me.CurrentTarget.IsCasting
                    && Me.CanInterruptCurrentSpellCast)
                    && Me.CurrentTarget.IsWithinMeleeRange)
                {
                    if (SpellManager.CanCast(SkullBashBear))
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool burstbossbear
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && IsBoss
                    && !spellOnCooldown(BerserkBear)
                    && !spellOnCooldown(IncarnationBear)
                    && FeralKittySettings.AllPrefs.BerserkBear == 1)
                {
                    return true;
                }
                return false;
            }
        }
        public bool burstbear
        {
            get
            {
                if (Me.CurrentTarget != null
                    && Me.CurrentTarget.IsAlive
                    && !spellOnCooldown(BerserkBear)
                    && !spellOnCooldown(IncarnationBear)
                    && FeralKittySettings.AllPrefs.BerserkBear == 2)
                {
                    return true;
                }
                return false;
            }
        }
    }
}
