﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FeralKitty
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            FeralKittySettings.AllPrefs.Load();

            checkBoxDiasblaTargetting.Checked = FeralKittySettings.AllPrefs.DisableTargetting;
            checkBoxDisableFacing.Checked = FeralKittySettings.AllPrefs.DisableFacing;
            checkBoxDisableMovement.Checked = FeralKittySettings.AllPrefs.DisableMovement;
            checkBox3.Checked = FeralKittySettings.AllPrefs.MightyBash;
            checkBoxSkullBash.Checked = FeralKittySettings.AllPrefs.SkullBash;
            checkBoxMightyBashBear.Checked = FeralKittySettings.AllPrefs.MightyBashBear;
            checkBoxSkullBashBear.Checked = FeralKittySettings.AllPrefs.SkullBashBear;
            checkBox4.Checked = FeralKittySettings.AllPrefs.DisableMovementBear;
            checkBox5.Checked = FeralKittySettings.AllPrefs.DisableFacingBear;
            checkBox6.Checked = FeralKittySettings.AllPrefs.DisableTargettingBear;



            comboBoxMajorGlyphs1.SelectedItem = FeralKittySettings.AllPrefs.MajorGlyph1;
            comboBoxMajorGlyphs2.SelectedItem = FeralKittySettings.AllPrefs.MajorGlyph2;
            comboBoxMajorGlyphs3.SelectedItem = FeralKittySettings.AllPrefs.MajorGlyph3;
            comboBoxVirmenPotion.SelectedIndex = FeralKittySettings.AllPrefs.Mvirmenpotion;
            comboBoxAgilityFlask.SelectedIndex = FeralKittySettings.AllPrefs.Magilityflask;
            comboBoxAlchemyFlask.SelectedIndex = FeralKittySettings.AllPrefs.Malchemyflask;
            comboBoxTrinket1.SelectedIndex = FeralKittySettings.AllPrefs.Mtrinket1;
            comboBoxTrinket2.SelectedIndex = FeralKittySettings.AllPrefs.Mtrinket2;
            comboBoxEngiGloves.SelectedIndex = FeralKittySettings.AllPrefs.Mengigloves;
            comboBoxEngiglovesBear.SelectedIndex = FeralKittySettings.AllPrefs.BengiglovesBear;
            
            comboBoxHealthstone.SelectedIndex = FeralKittySettings.AllPrefs.PHealthStone;
            comboBoxHealthpotion.SelectedIndex = FeralKittySettings.AllPrefs.PHealthPotion;
            comboBoxLifeSpirit.SelectedIndex = FeralKittySettings.AllPrefs.PLifeSpirit;
            comboBoxBerserk.SelectedIndex = FeralKittySettings.AllPrefs.Berserk;
            comboBoxBerserking.SelectedIndex = FeralKittySettings.AllPrefs.Berserking;
            comboBox1.SelectedIndex = FeralKittySettings.AllPrefs.DeathCoil;
            comboBox2.SelectedIndex = FeralKittySettings.AllPrefs.FeralSpirit;
            comboBox3.SelectedIndex = FeralKittySettings.AllPrefs.ShatteringBlow;
            comboBox4.SelectedIndex = FeralKittySettings.AllPrefs.SoulSwap;
            comboBox5.SelectedIndex = FeralKittySettings.AllPrefs.ChooseForm;
            comboBoxBearFormKey.SelectedIndex = FeralKittySettings.AllPrefs.BearFormKey;
            switch (comboBoxBearFormKey.SelectedIndex)
            {
                case 0:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.None;
                    break;
                case 1:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.LSHIFT;
                    break;
                case 2:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.RSHIFT;
                    break;
                case 3:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.LCTRL;
                    break;
                case 4:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.RCTRL;
                    break;
                case 5:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.LALT;
                    break;
                case 6:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.RALT;
                    break;
            }

            comboBoxPauseKey.SelectedIndex = FeralKittySettings.AllPrefs.PauseKey;
            switch (FeralKittySettings.AllPrefs.PauseKey)
            {
                case 0:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.None;
                    break;
                case 1:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.LSHIFT;
                    break;
                case 2:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.RSHIFT;
                    break;
                case 3:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.LCTRL;
                    break;
                case 4:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.RCTRL;
                    break;
                case 5:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.LALT;
                    break;
                case 6:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.RALT;
                    break;
            }
            comboBoxVirmenGuardian.SelectedIndex = FeralKittySettings.AllPrefs.virmenBear;
            comboBoxFlaskEarth.SelectedIndex = FeralKittySettings.AllPrefs.Earthflask;
            comboBox6.SelectedIndex = FeralKittySettings.AllPrefs.LifebloodBear;
            comboBoxLifebloodCat.SelectedIndex = FeralKittySettings.AllPrefs.Lifeblood;
            comboBoxAlchemyFlaskBear.SelectedIndex = FeralKittySettings.AllPrefs.BalchemyflaskBear;
            comboBoxTrinket1Bear.SelectedIndex = FeralKittySettings.AllPrefs.Btrinket1Bear;
            comboBoxTrinket2Bear.SelectedIndex = FeralKittySettings.AllPrefs.Btrinket2Bear;
            comboBoxBerserkBear.SelectedIndex = FeralKittySettings.AllPrefs.BerserkBear;
            comboBoxBerserkingBear.SelectedIndex = FeralKittySettings.AllPrefs.BerserkingBear;
            comboBoxNaturesVigil.SelectedIndex = FeralKittySettings.AllPrefs.NaturesVigil;


            numericUpDownSwitchBearForm.Value = new decimal(FeralKittySettings.AllPrefs.UseBearForm);
            numericUpDown14.Value = new decimal(FeralKittySettings.AllPrefs.EliteHealth);
            numericUpDownHealingTouch.Value = new decimal(FeralKittySettings.AllPrefs.HealingTouch);
            numericUpDownCanarionWard.Value = new decimal(FeralKittySettings.AllPrefs.CenarionWard);
            numericUpDownBarskin.Value = new decimal(FeralKittySettings.AllPrefs.Barskin);
            numericUpDownSurvivalInstincts.Value = new decimal(FeralKittySettings.AllPrefs.SurvivalInstincts);
            numericUpDownFrenziedRegeneration.Value = new decimal(FeralKittySettings.AllPrefs.FrenziedRegeneration);
            numericUpDownMightOfUrsoc.Value = new decimal(FeralKittySettings.AllPrefs.MightOfUrsoc);
            numericUpDownHealthstonePercent.Value = new decimal(FeralKittySettings.AllPrefs.PHealthStoneHealth);
            numericUpDownHealthPotionPercent.Value = new decimal(FeralKittySettings.AllPrefs.PHealthPotionHealth);
            numericUpDownLifeSpiritPercent.Value = new decimal(FeralKittySettings.AllPrefs.PLifeSpiritHealth);
            numericUpDownHealingToucOOC.Value = new decimal(FeralKittySettings.AllPrefs.HealingTouchOOC);
            numericUpDownRejuvenationOOC.Value = new decimal(FeralKittySettings.AllPrefs.RejuvenationOOC);
            numericUpDownEatDrinkOOC.Value = new decimal(FeralKittySettings.AllPrefs.EatDrinkOOC);
            numericUpDownDivineShield.Value = new decimal(FeralKittySettings.AllPrefs.DivineShield);
            numericUpDownDispersion.Value = new decimal(FeralKittySettings.AllPrefs.Dispersion);
            numericUpDownElitesBear.Value = new decimal(FeralKittySettings.AllPrefs.EliteHealthBear);

        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Save();
            Close();
        }

        private void comboBoxMajorGlyphs1_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.MajorGlyph1 = (string)comboBoxMajorGlyphs1.SelectedItem;
        }

        private void comboBoxMajorGlyphs2_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.MajorGlyph2 = (string)comboBoxMajorGlyphs2.SelectedItem;
        }

        private void comboBoxMajorGlyphs3_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.MajorGlyph3 = (string)comboBoxMajorGlyphs3.SelectedItem;
        }

        private void numericUpDownSwitchBearForm_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.UseBearForm = (int)numericUpDownSwitchBearForm.Value;
        }

        private void comboBoxVirmenPotion_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Mvirmenpotion = comboBoxVirmenPotion.SelectedIndex;
        }

        private void comboBoxAgilityFlask_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Magilityflask = comboBoxAgilityFlask.SelectedIndex;
        }

        private void comboBoxAlchemyFlask_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Malchemyflask = comboBoxAlchemyFlask.SelectedIndex;
        }

        private void comboBoxTrinket1_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Mtrinket1 = comboBoxTrinket1.SelectedIndex;
        }

        private void comboBoxTrinket2_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Mtrinket2 = comboBoxTrinket2.SelectedIndex;
        }

        private void comboBoxEngiGloves_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Mengigloves = comboBoxEngiGloves.SelectedIndex;
        } 

        private void numericUpDown14_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.EliteHealth = (int)numericUpDown14.Value;
        }

        private void checkBoxDisableMovement_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DisableMovement = checkBoxDisableMovement.Checked;
        }

        private void checkBoxDisableFacing_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DisableFacing = checkBoxDisableFacing.Checked;
        }

        private void checkBoxDiasblaTargetting_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DisableTargetting = checkBoxDiasblaTargetting.Checked;
        }

        private void numericUpDownHealingTouch_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.HealingTouch = (int)numericUpDownHealingTouch.Value;
        }

        private void numericUpDownCanarionWard_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.CenarionWard = (int)numericUpDownCanarionWard.Value;
        }

        private void numericUpDownBarskin_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Barskin = (int)numericUpDownBarskin.Value;
        }

        private void numericUpDownSurvivalInstincts_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.SurvivalInstincts = (int)numericUpDownSurvivalInstincts.Value;
        }

        private void numericUpDownFrenziedRegeneration_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.FrenziedRegeneration = (int)numericUpDownFrenziedRegeneration.Value;
        }

        private void numericUpDownMightOfUrsoc_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.MightOfUrsoc = (int)numericUpDownMightOfUrsoc.Value;
        }

        private void comboBoxHealthstone_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.PHealthStone = comboBoxHealthstone.SelectedIndex;
        }

        private void comboBoxHealthpotion_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.PHealthPotion = comboBoxHealthpotion.SelectedIndex;
        }

        private void comboBoxLifeSpirit_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.PLifeSpirit = comboBoxLifeSpirit.SelectedIndex;
        }

        private void numericUpDownHealthstonePercent_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.PHealthStoneHealth = (int)numericUpDownHealthstonePercent.Value;
        }

        private void numericUpDownHealthPotionPercent_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.PHealthPotionHealth = (int)numericUpDownHealthPotionPercent.Value;
        }

        private void numericUpDownLifeSpiritPercent_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.PLifeSpiritHealth = (int)numericUpDownLifeSpiritPercent.Value;
        }

        private void numericUpDownHealingToucOOC_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.HealingTouchOOC = (int)numericUpDownHealingToucOOC.Value;
        }

        private void numericUpDownRejuvenationOOC_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.RejuvenationOOC = (int)numericUpDownRejuvenationOOC.Value;
        }

        private void numericUpDownEatDrinkOOC_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.EatDrinkOOC = (int)numericUpDownEatDrinkOOC.Value;
        }

        private void comboBoxBerserk_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Berserk = comboBoxBerserk.SelectedIndex;
        }

        private void comboBoxBerserking_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Berserking = comboBoxBerserking.SelectedIndex;
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.MightyBash = checkBox3.Checked;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DeathCoil = comboBox1.SelectedIndex;
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.FeralSpirit = comboBox2.SelectedIndex;
        }

        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.ShatteringBlow = comboBox3.SelectedIndex;
        }

        private void comboBox4_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.SoulSwap = comboBox4.SelectedIndex;
        }

        private void numericUpDownDivineShield_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DivineShield = (int)numericUpDownDivineShield.Value;
        }

        private void checkBoxSkullBash_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.SkullBash = checkBoxSkullBash.Checked;
        }

        private void numericUpDownDispersion_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Dispersion = (int)numericUpDownDispersion.Value;
        }

        private void comboBoxPauseKey_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.PauseKey = comboBoxPauseKey.SelectedIndex;
            switch (comboBoxPauseKey.SelectedIndex)
            {
                case 0:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.None;
                    break;
                case 1:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.LSHIFT;
                    break;
                case 2:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.RSHIFT;
                    break;
                case 3:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.LCTRL;
                    break;
                case 4:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.RCTRL;
                    break;
                case 5:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.LALT;
                    break;
                case 6:
                    FeralKittySettings.AllPrefs.PauseKeys = FeralKittySettings.Keypress.RALT;
                    break;
            }
        }

        private void comboBox5_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.ChooseForm = comboBox5.SelectedIndex;
        }  

        private void checkBoxMightyBashBear_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.MightyBashBear = checkBoxMightyBashBear.Checked;
        }

        private void checkBoxSkullBashBear_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.SkullBashBear = checkBoxSkullBashBear.Checked;
        }

        private void comboBoxVirmenGuardian_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.virmenBear = comboBoxVirmenGuardian.SelectedIndex;
        }

        private void comboBoxFlaskEarth_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Earthflask = comboBoxFlaskEarth.SelectedIndex;
        }

        private void comboBox6_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.LifebloodBear = comboBox6.SelectedIndex;
        }

        private void comboBoxLifebloodCat_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Lifeblood = comboBoxLifebloodCat.SelectedIndex;
        }

        private void comboBoxAlchemyFlaskBear_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.BalchemyflaskBear = comboBoxAlchemyFlaskBear.SelectedIndex;
        }

        private void comboBoxTrinket1Bear_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Btrinket1Bear = comboBoxTrinket1Bear.SelectedIndex;
        }

        private void comboBoxTrinket2Bear_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.Btrinket2Bear = comboBoxTrinket2Bear.SelectedIndex;
        }

        private void comboBoxBerserkBear_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.BerserkBear = comboBoxBerserkBear.SelectedIndex;
        }

        private void comboBoxBerserkingBear_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.BerserkingBear = comboBoxBerserkingBear.SelectedIndex;
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DisableMovementBear = checkBox4.Checked;
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DisableFacingBear = checkBox5.Checked;
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.DisableTargettingBear = checkBox6.Checked;
        }

        private void numericUpDownElitesBear_ValueChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.EliteHealthBear = (int)numericUpDownElitesBear.Value;
        }

        private void comboBoxNaturesVigil_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.NaturesVigil = comboBoxNaturesVigil.SelectedIndex;
        }

        private void comboBoxEngiglovesBear_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.BengiglovesBear = comboBoxEngiglovesBear.SelectedIndex;
        }

        private void comboBoxBearFormKey_SelectedIndexChanged(object sender, EventArgs e)
        {
            FeralKittySettings.AllPrefs.BearFormKey = comboBoxBearFormKey.SelectedIndex;
            switch (comboBoxBearFormKey.SelectedIndex)
            {
                case 0:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.None;
                    break;
                case 1:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.LSHIFT;
                    break;
                case 2:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.RSHIFT;
                    break;
                case 3:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.LCTRL;
                    break;
                case 4:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.RCTRL;
                    break;
                case 5:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.LALT;
                    break;
                case 6:
                    FeralKittySettings.AllPrefs.BearFormKeys = FeralKittySettings.Keypress.RALT;
                    break;
            }
        }

         

         
        
    }
}
